diff -Nur linux-2.4.30/drivers/mtd/nand/nand.c linux-2.4.30-linux-mips.org/drivers/mtd/nand/nand.c
--- linux-2.4.30/drivers/mtd/nand/nand.c	2003-06-13 16:51:34.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/mtd/nand/nand.c	2005-05-12 18:01:29.000000000 +0200
@@ -753,141 +1073,306 @@
 	nand_get_chip (this, mtd , FL_READING, &erase_state);
 
 	/* Select the NAND device */
-	nand_select ();
+	this->select_chip(mtd, chipnr);
 
 	/* Send the read command */
-	this->cmdfunc (mtd, NAND_CMD_READOOB, col, page);
+	this->cmdfunc (mtd, NAND_CMD_READOOB, col, page & this->pagemask);
 	/* 
 	 * Read the data, if we read more than one page
 	 * oob data, let the device transfer the data !
 	 */
-	for (i = 0; i < len; i++) {
-		buf[i] = readb (this->IO_ADDR_R);
-		if ((col++ & (mtd->oobsize - 1)) == (mtd->oobsize - 1))
-			udelay (this->chip_delay);
+	i = 0;
+	while (i < len) {
+		int thislen = (mtd->oobsize - col) & (mtd->oobsize - 1);
+		if (!thislen)
+			thislen = mtd->oobsize;
+		thislen = min_t(int, thislen, len);
+		this->read_buf(mtd, &buf[i], thislen);
+		i += thislen;
+		col += thislen;
+		/* Read more ? */
+		if (i < len) {
+			page++;
+			/* Apply delay or wait for ready/busy pin 
+			 * Do this before the AUTOINCR check, so no problems
+			 * arise if a chip which does auto increment
+			 * is marked as NOAUTOINCR by the board driver.
+			*/
+			if (!this->dev_ready) 
+				udelay (this->chip_delay);
+			else
+				while (!this->dev_ready(mtd));	
+
+			/* Check, if we cross a chip boundary */
+			if (!(page & this->pagemask)) {
+				chipnr++;
+				this->select_chip(mtd, -1);
+				this->select_chip(mtd, chipnr);
+			}
+				
+			/* Check, if the chip supports auto page increment 
+			 * or if we have hit a block boundary. 
+			*/ 
+			if (!NAND_CANAUTOINCR(this) || !(page & blockcheck)) {
+				/* For subsequent page reads set offset to 0 */
+			        this->cmdfunc (mtd, NAND_CMD_READOOB, 0x0, page & this->pagemask);
+			}
+		}
 	}
-	/* De-select the NAND device */
-	nand_deselect ();
 
-	/* Wake up anyone waiting on the device */
-	spin_lock_bh (&this->chip_lock);
-	this->state = FL_READY;
-	wake_up (&this->wq);
-	spin_unlock_bh (&this->chip_lock);
+	/* Deselect and wake up anyone waiting on the device */
+	nand_release_chip(mtd);
 
 	/* Return happy */
 	*retlen = len;
 	return 0;
 }
 
+/* Prepare the out of band buffer 
+ *
+ * Return:
+ * 1. Filesystem buffer available and autoplacement is off,
+ *    return filesystem buffer
+ * 2. No filesystem buffer or autoplace is off, return internal
+ *    buffer
+ * 3. Filesystem buffer is given and autoplace selected
+ *    put data from fs buffer into internal buffer and
+ *    retrun internal buffer
+ *
+ * Note: The internal buffer is filled with 0xff. This must
+ * be done only once, when no autoplacement happens
+ * Autoplacement sets the buffer dirty flag, which
+ * forces the 0xff fill before using the buffer again.
+ *
+ * @mtd:	MTD device structure
+ * @fsbuf:	buffer given by fs driver
+ * @oobsel:	out of band selection structre
+ * @autoplace:	1 = place given buffer into the oob bytes
+ * @numpages:	number of pages to prepare
+*/
+static u_char * nand_prepare_oobbuf (struct mtd_info *mtd, u_char *fsbuf, struct nand_oobinfo *oobsel,
+		int autoplace, int numpages)
+{
+	struct nand_chip *this = mtd->priv;
+	int i, len, ofs;
+
+	/* Zero copy fs supplied buffer */
+	if (fsbuf && !autoplace) 
+		return fsbuf;
+
+	/* Check, if the buffer must be filled with ff again */
+	if (this->oobdirty) {	
+		memset (this->oob_buf, 0xff, 
+			mtd->oobsize << (this->erase_shift - this->page_shift));
+		this->oobdirty = 0;
+	}	
+	
+	/* If we have no autoplacement or no fs buffer use the internal one */
+	if (!autoplace || !fsbuf)
+		return this->oob_buf;
+	
+	/* Walk through the pages and place the data */
+	this->oobdirty = 1;
+	ofs = 0;
+	while (numpages--) {
+		for (i = 0, len = 0; len < mtd->oobavail; i++) {
+			int to = ofs + oobsel->oobfree[i][0];
+			int num = oobsel->oobfree[i][1];
+			memcpy (&this->oob_buf[to], fsbuf, num);
+			len += num;
+			fsbuf += num;
+		}
+		ofs += mtd->oobavail;
+	}
+	return this->oob_buf;
+}
+
+#define NOTALIGNED(x) (x & (mtd->oobblock-1)) != 0
+
 /*
-*	Use NAND write ECC
+ * This function simply calls nand_write_ecc with oob buffer and oobsel = NULL
+ *
+ * @mtd:	MTD device structure
+ * @to:		offset to write to
+ * @len:	number of bytes to write
+ * @retlen:	pointer to variable to store the number of written bytes
+ * @buf:	the data to write
 */
 static int nand_write (struct mtd_info *mtd, loff_t to, size_t len, size_t * retlen, const u_char * buf)
 {
-	return (nand_write_ecc (mtd, to, len, retlen, buf, NULL, 0));
+	return (nand_write_ecc (mtd, to, len, retlen, buf, NULL, NULL));
 }			   
 /*
  * NAND write with ECC
+ *
+ * @mtd:	MTD device structure
+ * @to:		offset to write to
+ * @len:	number of bytes to write
+ * @retlen:	pointer to variable to store the number of written bytes
+ * @buf:	the data to write
+ * @eccbuf:	filesystem supplied oob data buffer
+ * @oobsel:	oob selection structure
  */
 static int nand_write_ecc (struct mtd_info *mtd, loff_t to, size_t len,
-			   size_t * retlen, const u_char * buf, u_char * eccbuf, int oobsel)
+			   size_t * retlen, const u_char * buf, u_char * eccbuf, struct nand_oobinfo *oobsel)
 {
-	int i, page, col, cnt, ret = 0, oob = 0, written = 0;
+	int startpage, page, ret = -EIO, oob = 0, written = 0, chipnr;
+	int autoplace = 0, numpages, totalpages;
 	struct nand_chip *this = mtd->priv;
+	u_char *oobbuf, *bufstart;
+	int ppblock = mtd->erasesize >> this->page_shift;
 
 	DEBUG (MTD_DEBUG_LEVEL3, "nand_write_ecc: to = 0x%08x, len = %i\n", (unsigned int) to, (int) len);
 
+	/* Initialize retlen, in case of early exit */
+	*retlen = 0;
+
 	/* Do not allow write past end of device */
 	if ((to + len) > mtd->size) {
-		DEBUG (MTD_DEBUG_LEVEL0, "nand_write_oob: Attempt to write past end of page\n");
+		DEBUG (MTD_DEBUG_LEVEL0, "nand_write_ecc: Attempt to write past end of page\n");
 		return -EINVAL;
 	}
 
-	/* Shift to get page */
-	page = ((int) to) >> this->page_shift;
-
-	/* Get the starting column */
-	col = to & (mtd->oobblock - 1);
+	/* reject writes, which are not page aligned */	
+	if (NOTALIGNED (to) || NOTALIGNED(len)) {
+		printk (KERN_NOTICE "nand_write_ecc: Attempt to write not page aligned data\n");
+		return -EINVAL;
+	}
 
 	/* Grab the lock and see if the device is available */
 	nand_get_chip (this, mtd, FL_WRITING, NULL);
 
+	/* Calculate chipnr */
+	chipnr = (int)((unsigned long) to / this->chipsize);
 	/* Select the NAND device */
-	nand_select ();
+	this->select_chip(mtd, chipnr);
 
-	/* Check the WP bit */
-	this->cmdfunc (mtd, NAND_CMD_STATUS, -1, -1);
-	if (!(readb (this->IO_ADDR_R) & 0x80)) {
-		DEBUG (MTD_DEBUG_LEVEL0, "nand_write_ecc: Device is write protected!!!\n");
-		ret = -EIO;
+	/* Check, if it is write protected */
+	if (nand_check_wp(mtd))
 		goto out;
-	}
+
+	/* if oobsel is NULL, use chip defaults */
+	if (oobsel == NULL) 
+		oobsel = &mtd->oobinfo;		
+		
+	/* Autoplace of oob data ? Use the default placement scheme */
+	if (oobsel->useecc == MTD_NANDECC_AUTOPLACE) {
+		oobsel = this->autooob;
+		autoplace = 1;
+	}	
+
+	/* Setup variables and oob buffer */
+	totalpages = len >> this->page_shift;
+	page = ((int) to) >> this->page_shift;
+	/* Invalidate the page cache, if we write to the cached page */
+	if (page <= this->pagebuf && this->pagebuf < (page + totalpages))  
+		this->pagebuf = -1;
+	
+	/* Set it relative to chip */
+	page &= this->pagemask;
+	startpage = page;
+	/* Calc number of pages we can write in one go */
+	numpages = min (ppblock - (startpage  & (ppblock - 1)), totalpages);
+	oobbuf = nand_prepare_oobbuf (mtd, eccbuf, oobsel, autoplace, numpages);
+	bufstart = (u_char *)buf;
 
 	/* Loop until all data is written */
 	while (written < len) {
-		/* 
-		 * Check, if we have a full page write, then we can
-		 * use the given buffer, else we have to copy
+
+		this->data_poi = (u_char*) &buf[written];
+		/* Write one page. If this is the last page to write
+		 * or the last page in this block, then use the
+		 * real pageprogram command, else select cached programming
+		 * if supported by the chip.
 		 */
-		if (!col && (len - written) >= mtd->oobblock) {   
-			this->data_poi = (u_char*) &buf[written];
-			cnt = mtd->oobblock;
-		} else {
-			cnt = 0;
-			for (i = col; i < len && i < mtd->oobblock; i++) {
-				this->data_buf[i] = buf[written + i];
-				cnt++;
-			}
-			this->data_poi = this->data_buf;		
-		}
-		/* We use the same function for write and writev !) */
-		if (eccbuf) {
-			ret = nand_write_page (mtd, this, page, col, cnt ,&eccbuf[oob], oobsel);
-			oob += mtd->oobsize;
-		} else 
-			ret = nand_write_page (mtd, this, page, col, cnt, NULL, oobsel);	
-		
-		if (ret)
+		ret = nand_write_page (mtd, this, page, &oobbuf[oob], oobsel, (--numpages > 0));
+		if (ret) {
+			DEBUG (MTD_DEBUG_LEVEL0, "nand_write_ecc: write_page failed %d\n", ret);
 			goto out;
-
+		}	
+		/* Next oob page */
+		oob += mtd->oobsize;
 		/* Update written bytes count */
-		written += cnt;
-		/* Next write is aligned */
-		col = 0;
+		written += mtd->oobblock;
+		if (written == len) 
+			goto cmp;
+		
 		/* Increment page address */
 		page++;
+
+		/* Have we hit a block boundary ? Then we have to verify and
+		 * if verify is ok, we have to setup the oob buffer for
+		 * the next pages.
+		*/
+		if (!(page & (ppblock - 1))){
+			int ofs;
+			this->data_poi = bufstart;
+			ret = nand_verify_pages (mtd, this, startpage, 
+				page - startpage,
+				oobbuf, oobsel, chipnr, (eccbuf != NULL));
+			if (ret) {
+				DEBUG (MTD_DEBUG_LEVEL0, "nand_write_ecc: verify_pages failed %d\n", ret);
+				goto out;
+			}	
+			*retlen = written;
+
+			ofs = autoplace ? mtd->oobavail : mtd->oobsize;
+			if (eccbuf)
+				eccbuf += (page - startpage) * ofs;
+			totalpages -= page - startpage;
+			numpages = min (totalpages, ppblock);
+			page &= this->pagemask;
+			startpage = page;
+			oobbuf = nand_prepare_oobbuf (mtd, eccbuf, oobsel, 
+					autoplace, numpages);
+			/* Check, if we cross a chip boundary */
+			if (!page) {
+				chipnr++;
+				this->select_chip(mtd, -1);
+				this->select_chip(mtd, chipnr);
+			}
+		}
 	}
+	/* Verify the remaining pages */
+cmp:
+	this->data_poi = bufstart;
+ 	ret = nand_verify_pages (mtd, this, startpage, totalpages,
+		oobbuf, oobsel, chipnr, (eccbuf != NULL));
+	if (!ret)
+		*retlen = written;
+	else	
+		DEBUG (MTD_DEBUG_LEVEL0, "nand_write_ecc: verify_pages failed %d\n", ret);
 
 out:
-	/* De-select the NAND device */
-	nand_deselect ();
-
-	/* Wake up anyone waiting on the device */
-	spin_lock_bh (&this->chip_lock);
-	this->state = FL_READY;
-	wake_up (&this->wq);
-	spin_unlock_bh (&this->chip_lock);
+	/* Deselect and wake up anyone waiting on the device */
+	nand_release_chip(mtd);
 
-	*retlen = written;
 	return ret;
 }
 
+
 /*
  * NAND write out-of-band
+ *
+ * @mtd:	MTD device structure
+ * @to:		offset to write to
+ * @len:	number of bytes to write
+ * @retlen:	pointer to variable to store the number of written bytes
+ * @buf:	the data to write
  */
 static int nand_write_oob (struct mtd_info *mtd, loff_t to, size_t len, size_t * retlen, const u_char * buf)
 {
-	int i, column, page, status, ret = 0;
+	int column, page, status, ret = -EIO, chipnr;
 	struct nand_chip *this = mtd->priv;
 
 	DEBUG (MTD_DEBUG_LEVEL3, "nand_write_oob: to = 0x%08x, len = %i\n", (unsigned int) to, (int) len);
 
 	/* Shift to get page */
 	page = ((int) to) >> this->page_shift;
+	chipnr = (int)((unsigned long)to / this->chipsize);
 
 	/* Mask to get column */
-	column = to & 0x1f;
+	column = to & (mtd->oobsize - 1);
 
 	/* Initialize return length value */
 	*retlen = 0;
@@ -902,28 +1387,38 @@
 	nand_get_chip (this, mtd, FL_WRITING, NULL);
 
 	/* Select the NAND device */
-	nand_select ();
+	this->select_chip(mtd, chipnr);
 
-	/* Check the WP bit */
-	this->cmdfunc (mtd, NAND_CMD_STATUS, -1, -1);
-	if (!(readb (this->IO_ADDR_R) & 0x80)) {
-		DEBUG (MTD_DEBUG_LEVEL0, "nand_write_oob: Device is write protected!!!\n");
-		ret = -EIO;
+	/* Reset the chip. Some chips (like the Toshiba TC5832DC found
+	   in one of my DiskOnChip 2000 test units) will clear the whole
+	   data page too if we don't do this. I have no clue why, but
+	   I seem to have 'fixed' it in the doc2000 driver in
+	   August 1999.  dwmw2. */
+	this->cmdfunc(mtd, NAND_CMD_RESET, -1, -1);
+
+	/* Check, if it is write protected */
+	if (nand_check_wp(mtd))
 		goto out;
+	
+	/* Invalidate the page cache, if we write to the cached page */
+	if (page == this->pagebuf)
+		this->pagebuf = -1;
+
+	if (NAND_MUST_PAD(this)) {
+		/* Write out desired data */
+		this->cmdfunc (mtd, NAND_CMD_SEQIN, mtd->oobblock, page & this->pagemask);
+		/* prepad 0xff for partial programming */
+		this->write_buf(mtd, ffchars, column);
+		/* write data */
+		this->write_buf(mtd, buf, len);
+		/* postpad 0xff for partial programming */
+		this->write_buf(mtd, ffchars, mtd->oobsize - (len+column));
+	} else {
+		/* Write out desired data */
+		this->cmdfunc (mtd, NAND_CMD_SEQIN, mtd->oobblock + column, page & this->pagemask);
+		/* write data */
+		this->write_buf(mtd, buf, len);
 	}
-
-	/* Write out desired data */
-	this->cmdfunc (mtd, NAND_CMD_SEQIN, mtd->oobblock, page);
-	/* prepad 0xff for partial programming */
-	for (i = 0; i < column; i++)
-		writeb (0xff, this->IO_ADDR_W);
-	/* write data */
-	for (i = 0; i < len; i++)
-		writeb (buf[i], this->IO_ADDR_W);	
-	/* postpad 0xff for partial programming */
-	for (i = len + column; i < mtd->oobsize; i++)
-		writeb (0xff, this->IO_ADDR_W);
-
 	/* Send command to program the OOB data */
 	this->cmdfunc (mtd, NAND_CMD_PAGEPROG, -1, -1);
 
@@ -940,34 +1435,31 @@
 
 #ifdef CONFIG_MTD_NAND_VERIFY_WRITE
 	/* Send command to read back the data */
-	this->cmdfunc (mtd, NAND_CMD_READOOB, column, page);
+	this->cmdfunc (mtd, NAND_CMD_READOOB, column, page & this->pagemask);
 
-	/* Loop through and verify the data */
-	for (i = 0; i < len; i++) {
-		if (buf[i] != readb (this->IO_ADDR_R)) {
-			DEBUG (MTD_DEBUG_LEVEL0, "nand_write_oob: " "Failed write verify, page 0x%08x\n", page);
-			ret = -EIO;
-			goto out;
-		}
+	if (this->verify_buf(mtd, buf, len)) {
+		DEBUG (MTD_DEBUG_LEVEL0, "nand_write_oob: " "Failed write verify, page 0x%08x\n", page);
+		ret = -EIO;
+		goto out;
 	}
 #endif
-
+	ret = 0;
 out:
-	/* De-select the NAND device */
-	nand_deselect ();
-
-	/* Wake up anyone waiting on the device */
-	spin_lock_bh (&this->chip_lock);
-	this->state = FL_READY;
-	wake_up (&this->wq);
-	spin_unlock_bh (&this->chip_lock);
+	/* Deselect and wake up anyone waiting on the device */
+	nand_release_chip(mtd);
 
 	return ret;
 }
 
 
 /*
- * NAND write with iovec
+ * NAND write with iovec. This just calls the ecc function
+ *
+ * @mtd:	MTD device structure
+ * @vecs:	the iovectors to write
+ * @count:	number of vectors
+ * @to:		offset to write to
+ * @retlen:	pointer to variable to store the number of written bytes
  */
 static int nand_writev (struct mtd_info *mtd, const struct iovec *vecs, unsigned long count, 
 		loff_t to, size_t * retlen)
@@ -975,11 +1467,28 @@
 	return (nand_writev_ecc (mtd, vecs, count, to, retlen, NULL, 0));	
 }
 
+/*
+ * NAND write with iovec with ecc
+ *
+ * @mtd:	MTD device structure
+ * @vecs:	the iovectors to write
+ * @count:	number of vectors
+ * @to:		offset to write to
+ * @retlen:	pointer to variable to store the number of written bytes
+ * @eccbuf:	filesystem supplied oob data buffer
+ * @oobsel:	oob selection structure
+ */
 static int nand_writev_ecc (struct mtd_info *mtd, const struct iovec *vecs, unsigned long count, 
-		loff_t to, size_t * retlen, u_char *eccbuf, int oobsel)
+		loff_t to, size_t * retlen, u_char *eccbuf, struct nand_oobinfo *oobsel)
 {
-	int i, page, col, cnt, len, total_len, ret = 0, written = 0;
+	int i, page, len, total_len, ret = -EIO, written = 0, chipnr;
+	int oob, numpages, autoplace = 0, startpage;
 	struct nand_chip *this = mtd->priv;
+	int ppblock = mtd->erasesize >> this->page_shift;
+	u_char *oobbuf, *bufstart;
+
+	/* Preset written len for early exit */
+	*retlen = 0;
 
 	/* Calculate total length of data */
 	total_len = 0;
@@ -995,42 +1504,73 @@
 		return -EINVAL;
 	}
 
-	/* Shift to get page */
-	page = ((int) to) >> this->page_shift;
-
-	/* Get the starting column */
-	col = to & (mtd->oobblock - 1);
+	/* reject writes, which are not page aligned */	
+	if (NOTALIGNED (to) || NOTALIGNED(total_len)) {
+		printk (KERN_NOTICE "nand_write_ecc: Attempt to write not page aligned data\n");
+		return -EINVAL;
+	}
 
 	/* Grab the lock and see if the device is available */
 	nand_get_chip (this, mtd, FL_WRITING, NULL);
 
+	/* Get the current chip-nr */
+	chipnr = (int)((unsigned long) to / this->chipsize);
 	/* Select the NAND device */
-	nand_select ();
+	this->select_chip(mtd, chipnr);
 
-	/* Check the WP bit */
-	this->cmdfunc (mtd, NAND_CMD_STATUS, -1, -1);
-	if (!(readb (this->IO_ADDR_R) & 0x80)) {
-		DEBUG (MTD_DEBUG_LEVEL0, "nand_writev: Device is write protected!!!\n");
-		ret = -EIO;
+	/* Check, if it is write protected */
+	if (nand_check_wp(mtd))
 		goto out;
-	}
+
+	/* if oobsel is NULL, use chip defaults */
+	if (oobsel == NULL) 
+		oobsel = &mtd->oobinfo;		
+
+	/* Autoplace of oob data ? Use the default placement scheme */
+	if (oobsel->useecc == MTD_NANDECC_AUTOPLACE) {
+		oobsel = this->autooob;
+		autoplace = 1;
+	}	
+
+	/* Setup start page */
+	page = ((int) to) >> this->page_shift;
+	/* Invalidate the page cache, if we write to the cached page */
+	if (page <= this->pagebuf && this->pagebuf < ((to + total_len) >> this->page_shift))  
+		this->pagebuf = -1;
+
+	startpage = page & this->pagemask;
 
 	/* Loop until all iovecs' data has been written */
-	cnt = col;
 	len = 0;
-	
 	while (count) {
-		/* 
-		 *  Check, if we write from offset 0 and if the tuple
-		 *  gives us not enough data for a full page write. Then we
-		 *  can use the iov direct, else we have to copy into
-		 *  data_buf.		
+		/* If the given tuple is >= pagesize then
+		 * write it out from the iov
 		 */
-		if (!cnt && (vecs->iov_len - len) >= mtd->oobblock) {
-			cnt = mtd->oobblock;
-			this->data_poi = (u_char *) vecs->iov_base;
-			this->data_poi += len;
-			len += mtd->oobblock; 
+		if ((vecs->iov_len - len) >= mtd->oobblock) {
+			/* Calc number of pages we can write
+			 * out of this iov in one go */
+			numpages = (vecs->iov_len - len) >> this->page_shift;
+			/* Do not cross block boundaries */
+			numpages = min (ppblock - (startpage & (ppblock - 1)), numpages);
+			oobbuf = nand_prepare_oobbuf (mtd, NULL, oobsel, autoplace, numpages);
+			bufstart = (u_char *)vecs->iov_base;
+			bufstart += len;
+			this->data_poi = bufstart;
+			oob = 0;
+			for (i = 1; i <= numpages; i++) {
+				/* Write one page. If this is the last page to write
+				 * then use the real pageprogram command, else select 
+				 * cached programming if supported by the chip.
+				 */
+				ret = nand_write_page (mtd, this, page & this->pagemask, 
+					&oobbuf[oob], oobsel, i != numpages);
+				if (ret)
+					goto out;
+				this->data_poi += mtd->oobblock;
+				len += mtd->oobblock;
+				oob += mtd->oobsize;
+				page++;
+			}
 			/* Check, if we have to switch to the next tuple */
 			if (len >= (int) vecs->iov_len) {
 				vecs++;
@@ -1038,48 +1578,54 @@
 				count--;
 			}
 		} else {
-			/*
-			 * Read data out of each tuple until we have a full page
-			 * to write or we've read all the tuples.
-		 	*/
-			while ((cnt < mtd->oobblock) && count) {
-				if (vecs->iov_base != NULL && vecs->iov_len) {
+			/* We must use the internal buffer, read data out of each 
+			 * tuple until we have a full page to write
+			 */
+			int cnt = 0;
+			while (cnt < mtd->oobblock) {
+				if (vecs->iov_base != NULL && vecs->iov_len) 
 					this->data_buf[cnt++] = ((u_char *) vecs->iov_base)[len++];
-				}
 				/* Check, if we have to switch to the next tuple */
 				if (len >= (int) vecs->iov_len) {
 					vecs++;
 					len = 0;
 					count--;
 				}
-			}	
+			}
+			this->pagebuf = page;	
 			this->data_poi = this->data_buf;	
+			bufstart = this->data_poi;
+			numpages = 1;		
+			oobbuf = nand_prepare_oobbuf (mtd, NULL, oobsel, autoplace, numpages);
+			ret = nand_write_page (mtd, this, page & this->pagemask,
+				oobbuf, oobsel, 0);
+			if (ret)
+				goto out;
+			page++;
 		}
-		
-		/* We use the same function for write and writev !) */
-		ret = nand_write_page (mtd, this, page, col, cnt, NULL, oobsel);
+
+		this->data_poi = bufstart;
+		ret = nand_verify_pages (mtd, this, startpage, numpages, oobbuf, oobsel, chipnr, 0);
 		if (ret)
 			goto out;
+			
+		written += mtd->oobblock * numpages;
+		/* All done ? */
+		if (!count)
+			break;
 
-		/* Update written bytes count */
-		written += (cnt - col);
-
-		/* Reset written byte counter and column */
-		col = cnt = 0;
-
-		/* Increment page address */
-		page++;
+		startpage = page & this->pagemask;
+		/* Check, if we cross a chip boundary */
+		if (!startpage) {
+			chipnr++;
+			this->select_chip(mtd, -1);
+			this->select_chip(mtd, chipnr);
+		}
 	}
-
+	ret = 0;
 out:
-	/* De-select the NAND device */
-	nand_deselect ();
-
-	/* Wake up anyone waiting on the device */
-	spin_lock_bh (&this->chip_lock);
-	this->state = FL_READY;
-	wake_up (&this->wq);
-	spin_unlock_bh (&this->chip_lock);
+	/* Deselect and wake up anyone waiting on the device */
+	nand_release_chip(mtd);
 
 	*retlen = written;
 	return ret;
@@ -1087,12 +1633,14 @@
 
 /*
  * NAND erase a block
+ * 
+ * @mtd:	MTD device structure
+ * @instr:	erase instruction
  */
 static int nand_erase (struct mtd_info *mtd, struct erase_info *instr)
 {
-	int page, len, status, pages_per_block, ret;
+	int page, len, status, pages_per_block, ret, chipnr;
 	struct nand_chip *this = mtd->priv;
-	DECLARE_WAITQUEUE (wait, current);
 
 	DEBUG (MTD_DEBUG_LEVEL3,
 	       "nand_erase: start = 0x%08x, len = %i\n", (unsigned int) instr->addr, (unsigned int) instr->len);
@@ -1120,16 +1668,17 @@
 
 	/* Shift to get first page */
 	page = (int) (instr->addr >> this->page_shift);
+	chipnr = (int)((unsigned long)instr->addr / this->chipsize);
 
 	/* Calculate pages in each block */
-	pages_per_block = mtd->erasesize / mtd->oobblock;
+	pages_per_block = 1 << (this->erase_shift - this->page_shift);
 
 	/* Select the NAND device */
-	nand_select ();
+	this->select_chip(mtd, chipnr);
 
 	/* Check the WP bit */
 	this->cmdfunc (mtd, NAND_CMD_STATUS, -1, -1);
-	if (!(readb (this->IO_ADDR_R) & 0x80)) {
+	if (!(this->read_byte(mtd) & 0x80)) {
 		DEBUG (MTD_DEBUG_LEVEL0, "nand_erase: Device is write protected!!!\n");
 		instr->state = MTD_ERASE_FAILED;
 		goto erase_exit;
@@ -1142,22 +1691,23 @@
 
 	while (len) {
 		/* Check if we have a bad block, we do not erase bad blocks ! */
-		this->cmdfunc (mtd, NAND_CMD_READOOB, NAND_BADBLOCK_POS, page);
-		if (readb (this->IO_ADDR_R) != 0xff) {
+		if (this->block_bad(mtd, (loff_t) page, 0)) {
 			printk (KERN_WARNING "nand_erase: attempt to erase a bad block at page 0x%08x\n", page);
 			instr->state = MTD_ERASE_FAILED;
 			goto erase_exit;
 		}
+		
+		/* Invalidate the page cache, if we erase the block which contains 
+		   the current cached page */
+		if (page >= this->pagebuf && this->pagebuf < (page + pages_per_block))  
+			this->pagebuf = -1;
 
 		/* Send commands to erase a page */
-		this->cmdfunc (mtd, NAND_CMD_ERASE1, -1, page);
+		this->cmdfunc (mtd, NAND_CMD_ERASE1, -1, page & this->pagemask);
 		this->cmdfunc (mtd, NAND_CMD_ERASE2, -1, -1);
 
-		spin_unlock_bh (&this->chip_lock);
 		status = this->waitfunc (mtd, this, FL_ERASING);
 
-		/* Get spinlock, in case we exit */
-		spin_lock_bh (&this->chip_lock);
 		/* See if block erase succeeded */
 		if (status & 0x01) {
 			DEBUG (MTD_DEBUG_LEVEL0, "nand_erase: " "Failed erase, page 0x%08x\n", page);
@@ -1165,47 +1715,28 @@
 			goto erase_exit;
 		}
 		
-		/* Check, if we were interupted */
-		if (this->state == FL_ERASING) {
-			/* Increment page address and decrement length */
-			len -= mtd->erasesize;
-			page += pages_per_block;
-		}
-		/* Release the spin lock */
-		spin_unlock_bh (&this->chip_lock);
-erase_retry:
-		spin_lock_bh (&this->chip_lock);
-		/* Check the state and sleep if it changed */
-		if (this->state == FL_ERASING || this->state == FL_READY) {
-			/* Select the NAND device again, if we were interrupted */
-			this->state = FL_ERASING;
-			nand_select ();
-			continue;
-		} else {
-			set_current_state (TASK_UNINTERRUPTIBLE);
-			add_wait_queue (&this->wq, &wait);
-			spin_unlock_bh (&this->chip_lock);
-			schedule ();
-			remove_wait_queue (&this->wq, &wait);
-			goto erase_retry;
+		/* Increment page address and decrement length */
+		len -= mtd->erasesize;
+		page += pages_per_block;
+
+		/* Check, if we cross a chip boundary */
+		if (len && !(page & this->pagemask)) {
+			chipnr++;
+			this->select_chip(mtd, -1);
+			this->select_chip(mtd, chipnr);
 		}
 	}
 	instr->state = MTD_ERASE_DONE;
 
 erase_exit:
-	/* De-select the NAND device */
-	nand_deselect ();
-	spin_unlock_bh (&this->chip_lock);
 
 	ret = instr->state == MTD_ERASE_DONE ? 0 : -EIO;;
 	/* Do call back function */
 	if (!ret && instr->callback)
 		instr->callback (instr);
 
-	/* The device is ready */
-	spin_lock_bh (&this->chip_lock);
-	this->state = FL_READY;
-	spin_unlock_bh (&this->chip_lock);
+	/* Deselect and wake up anyone waiting on the device */
+	nand_release_chip(mtd);
 
 	/* Return more or less happy */
 	return ret;
@@ -1213,6 +1744,8 @@
 
 /*
  * NAND sync
+ *
+ * @mtd:	MTD device structure
  */
 static void nand_sync (struct mtd_info *mtd)
 {
@@ -1257,13 +1790,58 @@
 }
 
 /*
+ * Check whether the block at the given offset is bad
+ *
+ * @mtd:	MTD device structure
+ * @ofs:	offset relative to mtd start
+ */
+static int nand_block_isbad (struct mtd_info *mtd, loff_t ofs)
+{
+	struct nand_chip *this = mtd->priv;
+	
+	/* Check for invalid offset */
+	if (ofs > mtd->size) 
+		return -EINVAL;
+
+	return this->block_bad(mtd, ofs, 1);
+}
+
+/*
+ * Mark the block at the given offset as bad
+ *
+ * @mtd:	MTD device structure
+ * @ofs:	offset relative to mtd start
+ */
+static int nand_block_markbad (struct mtd_info *mtd, loff_t ofs)
+{
+	struct nand_chip *this = mtd->priv;
+		
+	/* Check for invalid offset */
+	if (ofs > mtd->size) 
+		return -EINVAL;
+
+	return this->block_markbad(mtd, ofs);
+}
+
+/*
  * Scan for the NAND device
+ *
+ * This fills out all the not initialized function pointers
+ * with the defaults.
+ * The flash ID is read and the mtd/chip structures are
+ * filled with the appropriate values.
+ *
+ * @mtd:	MTD device structure
+ * @maxchips:	Number of chips to scan for
  */
-int nand_scan (struct mtd_info *mtd)
+int nand_scan (struct mtd_info *mtd, int maxchips)
 {
-	int i, nand_maf_id, nand_dev_id;
+	int i, nand_maf_id, nand_dev_id, busw;
 	struct nand_chip *this = mtd->priv;
 
+	/* Get buswidth to select the correct functions*/
+	busw = this->options & NAND_BUSWIDTH_16;
+
 	/* check for proper chip_delay setup, set 20us if not */
 	if (!this->chip_delay)
 		this->chip_delay = 20;
